## google-perftools 2.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.11 LANGUAGES C CXX
+project(gperftools VERSION 2.12 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.12.5)
-set(PROFILER_SO_VERSION 5.7.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.7.6)
+set(TCMALLOC_SO_VERSION 9.13.5)
+set(PROFILER_SO_VERSION 5.8.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.8.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility
