=== debian/control ===
Source: google-perftools
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/gperftools/gperftools
Vcs-Git: https://salsa.debian.org/debian/google-perftools.git
Vcs-Browser: https://salsa.debian.org/debian/google-perftools

Package: libgoogle-perftools-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libgoogle-perftools4 (= ${binary:Version}), libtcmalloc-minimal4 (= ${binary:Version}), libunwind-dev [amd64]
Multi-Arch: same
Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs.  This
 includes an optimized thread-caching malloc() and cpu and heap profiling
 utilities.  The devel package contains static and debug libraries and header
 files for developing applications that use the google-perftools package.

Package: libtcmalloc-minimal4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This is a
 part of that package, and includes an optimized thread-caching malloc.

Package: libgoogle-perftools4
Architecture: any
Depends: libtcmalloc-minimal4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgoogle-perftools0
Multi-Arch: same
Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This includes
 the full features: an optimized thread-caching malloc() and cpu and heap
 profiling utilities.

Package: google-perftools
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4, curl
Suggests: libgoogle-perftools-dev
Recommends: graphviz, gv
Description: command line utilities to analyze the performance of C++ programs
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This is a
 part of that package, and includes command line utilities.
