=== debian/changelog ===
google-perftools (2.15-3build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:16:59 +0000

google-perftools (2.15-3) unstable; urgency=medium

  * Also disable _TIME_BITS in mmap_hook.cc to fix FTBFS on armel / armhf.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 07 Mar 2024 22:26:10 +0100

google-perftools (2.15-2) unstable; urgency=medium

  * Backport upstream fix for FTBFS on armel / armhf with disabling
    _FILE_OFFSET_BITS in mmap_hook.cc (closes: #1065167).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 02 Mar 2024 08:28:41 +0100

google-perftools (2.15-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062116

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 22:45:25 +0000

google-perftools (2.15-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 07 Jan 2024 11:18:34 +0100
