=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: google-perftools
 Section: libs
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
 Build-Conflicts: autoconf2.13, automake1.4
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
@@ -13,7 +14,7 @@
 Package: libgoogle-perftools-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libgoogle-perftools4 (= ${binary:Version}), libtcmalloc-minimal4 (= ${binary:Version}), libunwind-dev [amd64]
+Depends: ${misc:Depends}, libgoogle-perftools4t64 (= ${binary:Version}), libtcmalloc-minimal4t64 (= ${binary:Version}), libunwind-dev [amd64]
 Multi-Arch: same
 Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
  The gperftools, previously called google-perftools, package contains some
@@ -22,7 +23,10 @@
  utilities.  The devel package contains static and debug libraries and header
  files for developing applications that use the google-perftools package.
 
-Package: libtcmalloc-minimal4
+Package: libtcmalloc-minimal4t64
+Provides: ${t64:Provides}
+Replaces: libtcmalloc-minimal4
+Breaks: libtcmalloc-minimal4 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
@@ -31,9 +35,12 @@
  utilities to improve and analyze the performance of C++ programs. This is a
  part of that package, and includes an optimized thread-caching malloc.
 
-Package: libgoogle-perftools4
+Package: libgoogle-perftools4t64
+Provides: ${t64:Provides}
+Replaces: libgoogle-perftools4
+Breaks: libgoogle-perftools4 (<< ${source:Version})
 Architecture: any
-Depends: libtcmalloc-minimal4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libtcmalloc-minimal4t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgoogle-perftools0
 Multi-Arch: same
 Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
@@ -45,7 +52,7 @@
 Package: google-perftools
 Section: devel
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4, curl
+Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4t64, curl
 Suggests: libgoogle-perftools-dev
 Recommends: graphviz, gv
 Description: command line utilities to analyze the performance of C++ programs
