## google-perftools 2.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.15 LANGUAGES C CXX
+project(gperftools VERSION 2.16 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.16.5)
-set(PROFILER_SO_VERSION 5.11.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.11.6)
+set(TCMALLOC_SO_VERSION 9.18.5)
+set(PROFILER_SO_VERSION 5.13.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.13.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility
@@ -26,14 +26,12 @@
 set(DEFAULT_BUILD_MINIMAL OFF)
 
 set(DEFAULT_TCMALLOC_ALIGNMENT 16)
-set(NEED_NANOSLEEP ON) # Used later, to decide if to run ACX_NANOSLEEP
 
 set(HOST string(TOLOWER "${CMAKE_SYSTEM_NAME}"))
 
 if(MINGW OR MSVC)
   set(DEFAULT_BUILD_MINIMAL ON)
   set(DEFAULT_BUILD_DEBUGALLOC OFF)
-  set(NEED_NANOSLEEP OFF)
 elseif(CYGWIN)
   set(DEFAULT_BUILD_CPU_PROFILER OFF)
 endif()
@@ -55,8 +53,8 @@
 include(CheckVariableExists)
 include(CMakeDependentOption)
 include(CTest)
-include(CPack)
-include(GNUInstallDirs)
+
+option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 include(DefineTargetVariables)
@@ -168,12 +166,7 @@
   set(TCMALLOC_ALIGN_8BYTES ON)
 endif()
 
-# AX_CXX_COMPILE_STDCXX(11, ext, mandatory)
-if(cxx_std_17 IN_LIST CMAKE_CXX_COMPILE_FEATURES)
-  set(CMAKE_CXX_STANDARD 17) # std::align_val_t
-else()
-  set(CMAKE_CXX_STANDARD 11)
-endif()
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS ON)
 
@@ -193,13 +186,8 @@
 set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
 check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
 check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
-set(CMAKE_EXTRA_INCLUDE_FILES "elf.h")
-check_type_size("Elf32_Versym" ELF32_VERSYM LANGUAGE CXX) # for vdso_support.h
-set(CMAKE_EXTRA_INCLUDE_FILES)
 check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
-check_function_exists("__sbrk" HAVE___SBRK) # for tcmalloc to get memory
 check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
-check_function_exists("fork" HAVE_FORK) # for the pthread_atfork setup
 check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
 check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
 check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
@@ -211,9 +199,6 @@
 check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
 check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
 check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
-check_include_file("grp.h" HAVE_GRP_H) # for heapchecker_unittest
-check_include_file("pwd.h" HAVE_PWD_H) # for heapchecker_unittest
-check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H) # for memalign_unittest.cc
 check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW
 
 check_include_file("sys/ucontext.h" HAVE_SYS_UCONTEXT_H)
@@ -254,9 +239,6 @@
 if(NOT WIN32)
   set(HAVE_MMAP 1)
 endif()
-
-# Some tests test the behavior of .so files, and only make sense for dynamic.
-option(GPERFTOOLS_BUILD_STATIC "Enable Static" ON)
 
 if(gperftools_enable_libunwind)
   check_include_file("libunwind.h" HAVE_LIBUNWIND_H)
@@ -274,12 +256,6 @@
   endif()
 endif()
 
-# See if the compiler supports -Wno-unused-result.
-# Newer ubuntu's turn on -D_FORTIFY_SOURCE=2, enabling
-# __attribute__((warn_unused_result)) for things like write(),
-# which we don't care about.
-check_c_compiler_flag("-Wno-unused-result" have_w_no_unused_result)
-
 check_c_compiler_flag("-fno-omit-frame-pointer -momit-leaf-frame-pointer" have_omit_leaf_fp)
 check_c_source_compiles("
   #if !(__i386__ || __x86_64__ || __riscv || __aarch64__)
@@ -314,9 +290,62 @@
   set(CMAKE_REQUIRED_FLAGS)
 endif()
 
-check_cxx_source_compiles("
-  #include <new>
-  int main() { (::operator delete)((::operator new)(256, std::align_val_t(16)), std::align_val_t(16)); return 0; }"
-  HAVE_STD_ALIGN_VAL_T)
-if(HAVE_STD_ALIGN_VAL_T)
-  set(HAVE_STD_ALIGN_VAL_T 1)
+check_c_source_compiles("
+  #include <unwind.h>
+  int main()
+  {
+#if __APPLE__ || __FreeBSD__
+#error OSX _Unwind_Backtrace recurses back to malloc
+#endif
+    &_Unwind_Backtrace;
+    return 0;
+  }"
+  HAVE_UNWIND_BACKTRACE)
+
+if(enable_backtrace)
+  set(default_emergency_malloc ON)
+else()
+  set(default_emergency_malloc OFF)
+endif()
+
+if(will_use_libunwind AND ARM)
+  set(default_emergency_malloc ON)
+endif()
+
+option(gperftools_emergency_malloc
+       "Build emergency malloc"
+       ${default_emergency_malloc})
+
+check_c_source_compiles(
+  "int main() { return __builtin_expect(main != 0, 1); }"
+  HAVE_BUILTIN_EXPECT)
+
+check_c_source_compiles("
+  #include <unistd.h>
+  int main()
+  {
+    char** env = __environ;
+    return 0;
+  }"
+  HAVE___ENVIRON)
+
+if(enable_backtrace)
+  check_symbol_exists("backtrace" "execinfo.h" HAVE_DECL_BACKTRACE)
+  check_function_exists("backtrace" backtrace_exists)
+  if(NOT backtrace_exists)
+    set(CMAKE_REQUIRED_LIBRARIES execinfo)
+    check_function_exists("backtrace" backtrace_exists)
+    set(CMAKE_REQUIRED_LIBRARIES)
+    if(backtrace_exists)
+      list(INSERT unwind_libs 0 execinfo)
+    endif()
+  endif()
+endif()
+
+find_package(Threads REQUIRED)
+link_libraries(Threads::Threads)
+
+check_variable_exists("program_invocation_name" HAVE_PROGRAM_INVOCATION_NAME)
+
+if(MINGW)
+  check_symbol_exists("sleep" "unistd.h" HAVE_DECL_SLEEP)
