=== debian/changelog ===
google-perftools (2.16-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches applied upstream.
  * Update disable_profiler_unittest.patch .
  * Update Lintian overrides.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 27 Sep 2024 00:36:16 +0200
