=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: google-perftools
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
 Build-Conflicts: autoconf2.13, automake1.4
 Standards-Version: 4.6.2
