## google-perftools 2.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,25 +3,18 @@
 # Please note that cmake support is very preliminary. Autotools-based
 # build is the only fully supported build for now.
 
-# Based on configure.ac
-
-project(gperftools VERSION 2.16 LANGUAGES C CXX
+set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the build type")
+
+project(gperftools VERSION 2.18 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
-# Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.18.5)
-set(PROFILER_SO_VERSION 5.13.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.13.6)
-
-# The user can choose not to compile in the heap-profiler, the
-# heap-checker, or the cpu-profiler.  There's also the possibility
-# for a 'fully minimal' compile, which leaves out the stacktrace
-# code as well.  By default, we include all of these that the
-# target system supports.
+# The user can choose not to compile in the heap-profiler, or the
+# cpu-profiler.  There's also the possibility for a 'fully minimal'
+# compile, which leaves out the stacktrace code as well.  By default,
+# we include all of these that the target system supports.
 set(DEFAULT_BUILD_CPU_PROFILER ON)
 set(DEFAULT_BUILD_HEAP_PROFILER ON)
-set(DEFAULT_BUILD_HEAP_CHECKER OFF)
 set(DEFAULT_BUILD_DEBUGALLOC ON)
 set(DEFAULT_BUILD_MINIMAL OFF)
 
@@ -34,11 +27,6 @@
   set(DEFAULT_BUILD_DEBUGALLOC OFF)
 elseif(CYGWIN)
   set(DEFAULT_BUILD_CPU_PROFILER OFF)
-endif()
-
-# Heap checker is Linux-only (and deprecated).
-if(CMAKE_SYSTEM MATCHES Linux)
-  set(DEFAULT_BUILD_HEAP_CHECKER ON)
 endif()
 
 include(CheckCCompilerFlag)
@@ -90,9 +78,6 @@
   GPERFTOOLS_BUILD_HEAP_PROFILER "Build heap-profiler" ${DEFAULT_BUILD_HEAP_PROFILER}
   "NOT gperftools_build_minimal" OFF)
 cmake_dependent_option(
-  GPERFTOOLS_BUILD_HEAP_CHECKER "Build heap-checker" ${DEFAULT_BUILD_HEAP_CHECKER}
-  "NOT gperftools_build_minimal" OFF)
-cmake_dependent_option(
   GPERFTOOLS_BUILD_DEBUGALLOC "Build debugalloc" ${DEFAULT_BUILD_DEBUGALLOC}
   "NOT gperftools_build_minimal" OFF)
 option(
@@ -102,7 +87,6 @@
 if(gperftools_build_minimal)
   set(GPERFTOOLS_BUILD_CPU_PROFILER OFF)
   set(GPERFTOOLS_BUILD_HEAP_PROFILER OFF)
-  set(GPERFTOOLS_BUILD_HEAP_CHECKER OFF)
 endif()
 
 cmake_dependent_option(
@@ -122,6 +106,10 @@
        "Prefer libgcc's _Unwind_Backtrace as default stacktrace capturing method"
        OFF)
 set(PREFER_LIBGCC_UNWINDER ${gperftools_enable_libgcc_unwinder_by_default})
+
+option(gperftools_enable_broken_install_targets
+       "Install .so/.a libraries produced by this project"
+       OFF)
 
 set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize}
   CACHE STRING "Set the tcmalloc internal page size")
@@ -181,23 +169,17 @@
                         void foo(void) __attribute__((aligned(128)));
                         void foo(void) { exit(1); }
                         int main() { return 0; }"
-        HAVE___ATTRIBUTE__ALIGNED_FN) 
+        HAVE___ATTRIBUTE__ALIGNED_FN)
 
 set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
-check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
-check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
 check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
 check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
 check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
 check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
 check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
-check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace? and heapchecker_unittest
-check_include_file("unwind.h" HAVE_UNWIND_H) # for stacktrace
+check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace
 check_include_file("sched.h" HAVE_SCHED_H) # for being nice in our spinlock code
 check_include_file("sys/syscall.h" HAVE_SYS_SYSCALL_H)
-check_include_file("sys/socket.h" HAVE_SYS_SOCKET_H) # optional; for forking out to symbolizer
-check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
-check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
 check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
 check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW
 
@@ -213,24 +195,11 @@
 # We override a lot of memory allocation routines, not all of which are
 # standard.  For those the system doesn't declare, we'll declare ourselves.
 set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=600)
-check_symbol_exists("cfree" "stdlib.h;malloc.h" HAVE_DECL_CFREE)
 check_symbol_exists("posix_memalign" "stdlib.h;malloc.h" HAVE_DECL_POSIX_MEMALIGN)
 check_symbol_exists("memalign" "stdlib.h;malloc.h" HAVE_DECL_MEMALIGN)
 check_symbol_exists("valloc" "stdlib.h;malloc.h" HAVE_DECL_VALLOC)
 check_symbol_exists("pvalloc" "stdlib.h;malloc.h" HAVE_DECL_PVALLOC)
 set(CMAKE_REQUIRED_DEFINITIONS)
-
-if(HAVE_STRUCT_MALLINFO)
-    set(HAVE_STRUCT_MALLINFO 1)
-else()
-    set(HAVE_STRUCT_MALLINFO 0)
-endif()
-
-if(HAVE_STRUCT_MALLINFO2)
-    set(HAVE_STRUCT_MALLINFO2 1)
-else()
-    set(HAVE_STRUCT_MALLINFO2 0)
-endif()
 
 # We hardcode HAVE_MMAP to 1. There are no interesting systems anymore
 # without functional mmap. And our windows (except mingw) builds
@@ -290,7 +259,7 @@
   set(CMAKE_REQUIRED_FLAGS)
 endif()
 
-check_c_source_compiles("
+check_cxx_source_compiles("
   #include <unwind.h>
   int main()
   {
@@ -302,6 +271,13 @@
   }"
   HAVE_UNWIND_BACKTRACE)
 
+check_cxx_source_compiles("
+#include <cxxabi.h>
+int main() {
+  &__cxxabiv1::__cxa_demangle;
+}"
+  HAVE_CXA_DEMANGLE)
+
 if(enable_backtrace)
   set(default_emergency_malloc ON)
 else()
@@ -319,15 +295,6 @@
 check_c_source_compiles(
   "int main() { return __builtin_expect(main != 0, 1); }"
   HAVE_BUILTIN_EXPECT)
-
-check_c_source_compiles("
-  #include <unistd.h>
-  int main()
-  {
-    char** env = __environ;
-    return 0;
-  }"
-  HAVE___ENVIRON)
 
 if(enable_backtrace)
   check_symbol_exists("backtrace" "execinfo.h" HAVE_DECL_BACKTRACE)
@@ -349,3 +316,39 @@
 
 if(MINGW)
   check_symbol_exists("sleep" "unistd.h" HAVE_DECL_SLEEP)
+  check_symbol_exists("nanosleep" "time.h" HAVE_DECL_NANOSLEEP)
+endif()
+
+if(LINUX)
+  check_c_source_compiles("
+    #include <signal.h>
+    #include <time.h>
+    int main() { return SIGEV_THREAD_ID || CLOCK_THREAD_CPUTIME_ID; }"
+    HAVE_LINUX_SIGEV_THREAD_ID)
+endif()
+
+# Disable large allocation report by default.
+option(gperftools_enable_large_alloc_report
+      "Report very large allocations to stderr"
+      OFF)
+set(ENABLE_LARGE_ALLOC_REPORT ${gperftools_enable_large_alloc_report})
+
+# Enable aggressive decommit by default
+option(gperftools_enable_aggressive_decommit_by_default
+      "Enable aggressive decommit by default"
+      OFF)
+set(ENABLE_AGGRESSIVE_DECOMMIT_BY_DEFAULT ${gperftools_enable_aggressive_decommit_by_default})
+
+
+configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)
+
+if(GPERFTOOLS_BUILD_CPU_PROFILER OR
+   GPERFTOOLS_BUILD_HEAP_PROFILER)
+  set(WITH_STACK_TRACE ON)
+endif()
+
+include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>)
+# This is so we can #include <gperftools/foo>
+include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)
+
+if(NOT WITH_STACK_TRACE)
