=== debian/changelog ===
google-perftools (2.18-1) unstable; urgency=medium

  * New upstream release.
  * Remove google-perftools package, binaries no longer shipped
    (closes: #1049383).
  * Remove now redundant Rules-Requires-Root value.
  * Update watch file.
  * Refer online version of Free Software Foundation licence.
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 14 Feb 2026 11:53:31 +0100
