=== debian/control ===
--- 
+++ 
@@ -2,10 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
-Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
+Standards-Version: 4.7.2
 Homepage: https://github.com/gperftools/gperftools
 Vcs-Git: https://salsa.debian.org/debian/google-perftools.git
 Vcs-Browser: https://salsa.debian.org/debian/google-perftools
@@ -47,14 +45,3 @@
  utilities to improve and analyze the performance of C++ programs. This includes
  the full features: an optimized thread-caching malloc() and cpu and heap
  profiling utilities.
-
-Package: google-perftools
-Section: devel
-Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4t64, curl
-Suggests: libgoogle-perftools-dev
-Recommends: graphviz, gv
-Description: command line utilities to analyze the performance of C++ programs
- The gperftools, previously called google-perftools, package contains some
- utilities to improve and analyze the performance of C++ programs. This is a
- part of that package, and includes command line utilities.
