=== debian/rules ===
--- 
+++ 
@@ -12,16 +12,9 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	# rename binary
-	cd $(DESTDIR)/usr/bin && mv pprof google-pprof
-	cd $(DESTDIR)/usr/share/man/man1 && \
-		mv pprof.1 google-pprof.1 && \
-		sed -i 's/pprof/google-pprof/g' google-pprof.1
-	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
-		sed -i 's/pprof/google-pprof/g' README
 	# remove unwanted documentation
 	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
-		rm -f ChangeLog ChangeLog.old INSTALL README_windows.txt TODO
+		rm -f ChangeLog.old INSTALL README_windows.txt
 	# remove .la files
 	find $(DESTDIR) -name \*.la -exec rm {} \;
